Object.defineProperty(exports, '__esModule', { value: true });

var preact = require('preact');
var Portal = require('preact-portal');

function _extends() {
  _extends = Object.assign || function (target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];

      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }

    return target;
  };

  return _extends.apply(this, arguments);
}

function objectWithoutProperties(obj, exclude) {
  var target = {};

  for (var k in obj) if (Object.prototype.hasOwnProperty.call(obj, k) && exclude.indexOf(k) === -1) target[k] = obj[k];

  return target;
}

var HeadTag = function (Component) {
  function HeadTag() {
    Component.apply(this, arguments);
  }

  if (Component) HeadTag.__proto__ = Component;
  HeadTag.prototype = Object.create(Component && Component.prototype);
  HeadTag.prototype.constructor = HeadTag;

  HeadTag.prototype.componentDidMount = function componentDidMount() {
    this.setState({
      isClient: true
    });
    var ssrTag = document.head.querySelector("[data-pht]");

    if (ssrTag) {
      ssrTag.remove();
    }
  };

  HeadTag.prototype.render = function render(ref, ref$1) {
    var Tag = ref.tag;
    var rest$1 = objectWithoutProperties(ref, ["tag"]);
    var rest = rest$1;
    var isClient = ref$1.isClient;

    if (isClient) {
      return preact.h(Portal, {
        into: "head"
      }, preact.h(Tag, rest));
    }

    if (this.context.head) {
      this.context.head.add(preact.h(Tag, _extends({}, {
        'data-pht': true
      }, rest)));
    }
  };

  return HeadTag;
}(preact.Component);
var Title = function (props) {
  return preact.h(HeadTag, _extends({}, {
    tag: "title"
  }, props));
};
var Style = function (props) {
  return preact.h(HeadTag, _extends({}, {
    tag: "style"
  }, props));
};
var Meta = function (props) {
  return preact.h(HeadTag, _extends({}, {
    tag: "meta"
  }, props));
};
var Link = function (props) {
  return preact.h(HeadTag, _extends({}, {
    tag: "link"
  }, props));
};

exports.default = HeadTag;
exports.Title = Title;
exports.Style = Style;
exports.Meta = Meta;
exports.Link = Link;
